%define name		clamav
%define version		0.88

%define	major		1
%define libname	%mklibname %{name} %{major}

%define milter		1

%{?_with_milter:	%{expand: %%global milter 1}}
%{?_without_milter:	%{expand: %%global milter 0}}

Summary:	An anti-virus utility for Unix
Name:		%{name}
Version:	%{version}
Release	:	1.0%{_my_ext}
Vendor:		%{vendor}
Packager:	%{packager}
Distribution:	%{distribution}
License:	GPL
Group:		File tools
URL:		http://clamav.sourceforge.net/
Source0:	http://www.clamav.net/%{name}-%{version}.tar.gz
Source1:	clamav-clamd.init.bz2
Source2:	clamav-clamd.logrotate.bz2
Source3:	clamav-freshclamd.init.bz2
Source4:	clamav-freshclam.logrotate.bz2
Source5:	clamav-milter.init.bz2
Source6:	clamav-milter.sysconfig.bz2
PreReq:		clamav-db
PreReq:		rpm-helper
PreReq:		%{libname} = %{version}
BuildRequires:	bzip2-devel
BuildRequires:	curl-devel
BuildRequires:	bc
BuildRequires:	file
%if %mdkversion >= 1000
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
%endif
%if %{milter}
BuildRequires:	sendmail-devel
BuildRequires:	tcp_wrappers-devel
%endif
BuildRequires:	zlib-devel
BuildRequires:	gmp-devel
BuildRequires:	curl-devel
%if %mdkversion >= 1020
BuildRequires:	multiarch-utils >= 1.0.3
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description 
Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose
of this software is the integration with mail seversions (attachment
scanning). The package provides a flexible and scalable
multi-threaded daemon, a commandline scanner, and a tool for
automatic updating via Internet. The programs are based on a
shared library distributed with the Clam AntiVirus package, which
you can use in your own software. 

You can build %{name} with some conditional build switches;

(ie. use with rpm --rebuild):
    --with[out] milter	Build %{name}-milter (default)

%package -n	clamd
Summary:	The Clam AntiVirus Daemon
Group:		System/Servers
Requires:	%{name} = %{version}
PreReq:		rpm-helper
PreReq:		%{libname} = %{version}
PreReq:		clamav-db

%description -n	clamd
The Clam AntiVirus Daemon

%if %{milter}
%package -n	%{name}-milter
Summary:	The Clam AntiVirus sendmail-milter Daemon
Group:		System/Servers
Requires:	%{name} = %{version}
Requires:	clamd = %{version}
Requires:	sendmail
Requires:	tcp_wrappers
PreReq:		rpm-helper
PreReq:		%{libname} = %{version}
PreReq:		clamav-db

%description -n	%{name}-milter
The Clam AntiVirus sendmail-milter Daemon
%endif

%package -n	%{name}-db
Summary:	Virus database for %{name}
Group:		Databases
Requires:	%{name} = %{version}
PreReq:		rpm-helper

%description -n	%{name}-db
The actual virus database for %{name}

%package -n	%{libname}
Summary:	Shared libraries for %{name}
Group:          System/Libraries

%description -n	%{libname}
Shared libraries for %{name}

%package -n	%{libname}-devel
Summary:	Development library and header files for the %{name} library
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	%{name}-devel lib%{name}-devel
Obsoletes:	%{name}-devel lib%{name}-devel

%description -n	%{libname}-devel
This package contains the static %{libname} library and its header
files.

%prep

%setup -q -n %{name}-%{version}

# clean up
for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done
	
mkdir -p Mandrakelinux
bzcat %{SOURCE1} > Mandrakelinux/clamav-clamd.init
bzcat %{SOURCE2} > Mandrakelinux/clamav-clamd.logrotate
bzcat %{SOURCE3} > Mandrakelinux/clamav-freshclamd.init
bzcat %{SOURCE4} > Mandrakelinux/clamav-freshclam.logrotate
bzcat %{SOURCE5} > Mandrakelinux/clamav-milter.init
bzcat %{SOURCE6} > Mandrakelinux/clamav-milter.sysconfig

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
    
%build
%if %mdkversion > 1000
export WANT_AUTOCONF_2_5=1
libtoolize --copy --force && aclocal-1.7 && autoconf && automake-1.7
%endif

export SENDMAIL="%{_libdir}/sendmail"

%serverbuild

%configure2_5x \
    --disable-%{name} \
    --with-user=%{name} \
    --with-group=%{name} \
    --with-dbdir=%{_localstatedir}/%{name} \
    --enable-id-check \
    --enable-clamuko \
    --enable-bigstack \
    --with-libcurl \
    --with-zlib=%{_prefix} \
    --disable-zlib-vcheck \
%if %{milter}
    --enable-milter --with-tcpwrappers
%else
    --disable-milter --without-tcpwrappers
%endif			

%make 

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

# install the init scripts
install -d %{buildroot}%{_initrddir}
install -m755 Mandrakelinux/clamav-clamd.init %{buildroot}%{_initrddir}/clamd
install -m755 Mandrakelinux/clamav-freshclamd.init %{buildroot}%{_initrddir}/freshclam

%if %{milter}
# install the init script
install -m755 Mandrakelinux/clamav-milter.init %{buildroot}%{_initrddir}/clamav-milter
# install the milter config
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m644 Mandrakelinux/clamav-milter.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}-milter
%endif

# install the logrotate stuff
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -m644 Mandrakelinux/clamav-clamd.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/clamd
install -m644 Mandrakelinux/clamav-freshclam.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/freshclam

install -d %{buildroot}/var/log/%{name}
touch %{buildroot}/var/log/%{name}/freshclam.log
touch %{buildroot}/var/log/%{name}/clamd.log

# install config files
install -m644 etc/clamd.conf %{buildroot}%{_sysconfdir}/clamd.conf
install -m644 etc/freshclam.conf %{buildroot}%{_sysconfdir}/freshclam.conf

# pid file dir
install -d %{buildroot}/var/run/%{name}

# fix TMPDIR
install -d %{buildroot}%{_localstatedir}/%{name}/tmp

cat > README.qmail+qmail-scanner <<EOF
#!/bin/sh
#
# The "temporary" qmail+qmail-scanner HOWTO
# -----------------------------------------
#
# For some unknown and undocumented reason clamdscan stopped working
# in the excellent qmail+qmail-scanner setup somewhere after the
# 20040103 CVS snapshot.
#
# To get it working again everything assigned to the clamav user has
# to be changed to the qscand user by hand.
#
# Hint: Change the config and chown the directories like this:
# (if you are lazy you could just execute this file)

perl -pi -e "s|%{name} %{name}|qscand qscand|g" %{_sysconfdir}/logrotate.d/clamd
perl -pi -e "s|%{name} %{name}|qscand qscand|g" %{_sysconfdir}/logrotate.d/freshclam
perl -pi -e "s|^User %{name}|User qscand|g" %{_sysconfdir}/clamd.conf
perl -pi -e "s|^DatabaseOwner %{name}|DatabaseOwner qscand|g" %{_sysconfdir}/freshclam.conf

chown -R qscand:qscand %{_localstatedir}/%{name}
chown -R qscand:qscand /var/log/%{name}
chown -R qscand:qscand /var/run/%{name}

if [ -x %{_initrddir}/clamd ]; then
    %{_initrddir}/clamd restart
fi

if [ -x %{_initrddir}/freshclam ]; then
    %{_initrddir}/freshclam restart
fi

# Regards // Oden Eriksson
EOF

%if %mdkversion >= 1020
%multiarch_binaries %{buildroot}%{_bindir}/clamav-config
%endif

%pre
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh
%_pre_groupadd amavis %{name}

%post
%_post_service freshclam
%create_ghostfile /var/log/%{name}/freshclam.log %{name} %{name} 0644

%preun
%_preun_service freshclam

%pre -n clamd
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh

%post -n clamd
%_post_service clamd
%create_ghostfile /var/log/%{name}/clamd.log %{name} %{name} 0644

%preun -n clamd
%_preun_service clamd

%postun -n clamd
%_postun_userdel %{name}

%if %{milter}
%post -n %{name}-milter
%_post_service %{name}-milter

%preun -n %{name}-milter
%_preun_service %{name}-milter
%endif

%pre -n %{name}-db
%_pre_useradd %{name} %{_localstatedir}/%{name} /bin/sh

%post -n %{name}-db
# try to keep most uptodate database
for i in main daily; do
	if [ -f /var/lib/clamav/$i.cvd.rpmnew ]; then
		if [ /var/lib/clamav/$i.cvd.rpmnew -nt /var/lib/clamav/$i.cvd ]; then
			mv -f /var/lib/clamav/$i.cvd.rpmnew /var/lib/clamav/$i.cvd
		else
			rm -f /var/lib/clamav/$i.cvd.rpmnew
		fi
	fi
done

%postun -n %{name}-db
%_postun_userdel %{name}

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%post -n %{libname}-devel -p /sbin/ldconfig

%postun -n %{libname}-devel -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog FAQ NEWS README test UPGRADE
%doc docs/*.pdf contrib/clamdwatch contrib/clamavmon
%doc README.qmail+qmail-scanner COPYING
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/clamd.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/freshclam.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/freshclam
%attr(0755,root,root) %{_initrddir}/freshclam
%{_bindir}/clamscan
%{_bindir}/clamdscan
%{_bindir}/freshclam
%{_bindir}/sigtool
%{_mandir}/man1/sigtool.1*
%{_mandir}/man1/clamdscan.1*
%{_mandir}/man1/clamscan.1*
%{_mandir}/man1/freshclam.1*
%{_mandir}/man5/clamd.conf.5*
%{_mandir}/man5/freshclam.conf.5*
%if !%{milter}
%exclude %{_mandir}/man8/%{name}-milter.8*
%endif
%dir %attr(0755,%{name},%{name}) /var/run/%{name}
%dir %attr(0755,%{name},%{name}) %{_localstatedir}/%{name}
%dir %attr(0755,%{name},%{name}) /var/log/%{name}
%ghost %attr(0644,%{name},%{name}) /var/log/%{name}/freshclam.log

%files -n clamd
%defattr(-,root,root)
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/clamd.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/clamd
%attr(0755,root,root) %{_initrddir}/clamd
%{_sbindir}/clamd
%{_mandir}/man8/clamd.8*
%ghost %attr(0644,%{name},%{name}) /var/log/%{name}/clamd.log

%if %{milter}
%files -n %{name}-milter
%defattr(-,root,root)
%doc %{name}-milter/INSTALL
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}-milter
%attr(0755,root,root) %{_initrddir}/%{name}-milter
%{_sbindir}/%{name}-milter
%{_mandir}/man8/%{name}-milter.8*
%endif

%files -n %{name}-db
%defattr(-,root,root)
%dir %attr(0755,%{name},%{name}) %{_localstatedir}/%{name}
%attr(0644,%{name},%{name}) %config(noreplace) %{_localstatedir}/%{name}/daily.cvd
%attr(0644,%{name},%{name}) %config(noreplace) %{_localstatedir}/%{name}/main.cvd
%dir %attr(0755,%{name},%{name}) %{_localstatedir}/%{name}/tmp

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc contrib/clamdwatch
%doc contrib/Windows
%if %mdkversion >= 1020
%multiarch %{multiarch_bindir}/clamav-config
%endif
%{_bindir}/clamav-config
%{_includedir}/*
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/*.la
%{_libdir}/pkgconfig/libclamav.pc
      
%changelog

* Tue Jan 10 2006 Scott Grayban <sgrayban@borgnet.us> 0.88 -1bgn
- New version

* Fri Oct 7 2005 Scott Grayban <sgrayban@borgnet.us> 0.87
 - Build for 2006

* Fri Sep 16 2005 Scott Grayban <sgrayban@borgnet.us> 0.87-1bgn
- New version

* Fri Jun 24 2005 Scott Grayban <sgrayban@borgnet.us> 0.86.1-1bgn
- New version

* Fri Jun 3 2005 Scott Grayban <sgrayban@borgnet.us> 0.85.1-1bgn
- New version

* Fri May 13 2005 Scott Grayban <sgrayban@borgnet.us> 0.85-1bgn
- Build for mandriva 10.1 and 10.2

* Thu Mar 31 2005 Scott Grayban <sgrayban@borgnet.us> 0.83-1bgn
- Rebuilt for Mandrake 10.1 since Mandrake doesn't think this program
  needs to be current for any version.
